(function() {
var currentSelectedItemCallbackPrefix = "CBSI";
var loadDropDownOnDemandCallbackPrefix = "CBLD";
var listBoxNameSuffix = "_L";
var comboBoxValueInputSuffix = "VI";
var ASPxClientComboBoxBase = ASPx.CreateClass(ASPxClientDropDownEditBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.lbEventLockCount = 0;
  this.receiveGlobalMouseWheel = false;
  this.collectCallbackIDs = false;
  this.callbackIDs = { };
  this.callbackIDsToReset = { };
  this.accessibilityHelper = null;
  this.listBox = null;
  this.lastSuccessValue = "";
  this.islastSuccessValueInit = false;
  this.SelectedIndexChanged = new ASPxClientEvent();
 },
 Initialize: function(){
  this.InitializeListBoxOwnerName();
  ASPxClientDropDownEditBase.prototype.Initialize.call(this);
  this.InitLastSuccessValue();
 },
 InitializeListBoxOwnerName: function(){
  var lb = this.GetListBoxControl();
  if(lb)
   lb.ownerName = this.name;
 },
 InitLastSuccessValue: function(){
  this.SetLastSuccessValue(this.GetValue());
 },
 SetLastSuccessValue: function (value) {
  if(this.convertEmptyStringToNull && value === "")
   value = null;
  this.lastSuccessValue = value;
  this.islastSuccessValueInit = true;
 },
 GetDropDownInnerControlName: function(suffix){
  return "";
 },
 GetAccessibilityHelper: function() {
  if(!this.accessibilityCompliant)
   return null;
  if(!this.accessibilityHelper)
   this.accessibilityHelper = new AccessibilityHelperComboBox(this);
  return this.accessibilityHelper;
 },
 GetListBoxControl: function(){
  if(!ASPx.IsExists(this.listBox)){
   var name = this.GetDropDownInnerControlName(listBoxNameSuffix);
   this.listBox = ASPx.GetControlCollection().Get(name);
  }
  if(this.isNative || (this.listBox && !!this.listBox.GetMainElement()))
   return this.listBox;
  return null;
 },
 GetCallbackArguments: function(){
  return this.GetListBoxCallbackArguments();
 },
 GetListBoxCallbackArguments: function(){
  var lb = this.GetListBoxControl();
  return lb.GetCallbackArguments();
 },
 SendCallback: function(onSuccess) {
  var callbackID = this.CreateCallback(this.GetCallbackArguments(), null, onSuccess);
  this.OnCreateCallback(callbackID);
 },
 SendSpecialCallback: function(args, handler) {
  var callbackID = this.CreateCallback(args, null, handler);
  this.OnCreateCallback(callbackID);
 },
 OnCreateCallback: function(callbackID) {
  if(this.collectCallbackIDs)
   this.callbackIDs[callbackID] = true;
  this.UnlockDoEndCallback();
 },
 CanProcessCallbackResult: function(callbackID) {
  var result = !this.collectCallbackIDs || !this.callbackIDsToReset[callbackID];
  delete this.callbackIDs[callbackID];
  delete this.callbackIDsToReset[callbackID];
  if(!result)
   this.LockDoEndCallback();
  return result;
 },
 LockDoEndCallback: function() {
  this.lockDoEndCallback = true;
  this.lockDoEndCallbackTimerId =  window.setTimeout(function() { this.lockDoEndCallback = false; }.bind(this), 200);
 },
 UnlockDoEndCallback: function() {
  this.lockDoEndCallback = false;
  ASPx.Timer.ClearTimer(this.lockDoEndCallbackTimerId);
 },
 IsDoEndCallbackLocked: function() { 
  return !!this.lockDoEndCallback; 
 },
 ResetWaitingCallbacks: function() {
  var ids = Object.keys(this.callbackIDs);
  if(ids.length === 0) return;
  ids.forEach(function(id) { this.callbackIDsToReset[id] = true; }.bind(this));
  this.callbackIDs = { };
  this.requestCount = 0;
  ASPx.GetControlCollection().ResetRequestCount(); 
  this.CancelCallbackInternal();
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientDropDownEditBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  var lb = this.GetListBoxControl();
  if(lb)
   lb.SetReadOnly(readOnly);
 },
 SetText: function(text){
  var lb = this.GetListBoxControl();
  var index = this.GetAdjustedSelectedIndexByText(lb, text);
  var isAllowNullValue = !this.isDropDownListStyle || this.allowNull;
  var isChangingTextInEmpty = index < 0 && !text && this.lastSuccessText !== text;
  if(isAllowNullValue || !isChangingTextInEmpty) {
   this.SelectIndex(index, false);
   this.SetTextBase(text);
   this.SetLastSuccessText(text);
   this.SetLastSuccessValue(index >= 0 ? lb.GetValue() : text);
  }
 },
 GetValue: function(){
  var value = this.islastSuccessValueInit ? this.lastSuccessValue : this.GetValueInternal();
  if(this.convertEmptyStringToNull && value === "")
   value = null;
  return value;
 },
 GetValueInternal: function(){
  var text = this.GetTextInternal();
  var textChanges = text != this.lastSuccessText;
  if(textChanges){
   var lb = this.GetListBoxControl();
   if(lb){
    var index = this.GetAdjustedSelectedIndexByText(lb, text);
    this.SelectIndexSilent(lb, index); 
    if(index != -1)
     return lb.GetValue();
   }
  }
  return ASPxClientDropDownEditBase.prototype.GetValue.call(this);
 },
 GetLastSuccesfullValue: function() {
  return this.GetValue();
 },
 GetSetValueOptimizeHelper: function () {
  this.setValueOptimizeHelper = this.setValueOptimizeHelper || new setValueOptimizeHelper();
  return this.setValueOptimizeHelper;
 },
 SetValue: function (value) {
  this.GetSetValueOptimizeHelper().setValue(this, value);
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetLabelAttribute(null, null);
 },
 SetValueInternal: function(value) {
  var lb = this.GetListBoxControl();
  if (lb) {
   lb.SetValue(value);
   var item = lb.GetSelectedItem();
   var text = item ? item.text : value;
   this.OnSelectionChangedCore(text, item, false);
   this.UpdateValueInput();
  }
 },
 Clear: function() {
  ASPxClientDropDownEditBase.prototype.Clear.call(this);
  if(!this.GetListBoxControl())
   this.islastSuccessValueInit = false;
 },
 GetFormattedText: function() {
  return this.GetText();
 },
 GetAdjustedSelectedIndexByText: function(lb, text){
  if(!lb)
   return -1;
  var lbSelectedItem = lb.GetSelectedItem();
  if(lbSelectedItem != null && (lbSelectedItem.text == text || !this.isInitialized))
   return lbSelectedItem.index;
  return this.FindItemIndexByText(lb, text);
 },
 FindItemIndexByText: function(lb, text){
  if(lb)
   return lb.FindItemIndexByText(text);
 },
 CollectionChanged: function(){
 },
 HasChanges: function(){
  return false;
 },
 SelectIndex: function(index, initialize){
  var lb = this.GetListBoxControl();
  if(!lb)
   return false;
  var isSelectionChanged = lb.SelectIndexSilentAndMakeVisible(index, initialize);
  var item = lb.GetSelectedItem();
  var text = item != null ? item.text : "";
  if(isSelectionChanged || this.HasChanges())
   this.OnSelectionChangedCore(text, item, false);
  this.UpdateValueInput();
  return isSelectionChanged;
 },
 OnSelectChanged: function(){
  if(this.lbEventLockCount > 0) return;
  var lb = this.GetListBoxControl();
  var item = lb.GetSelectedItem();
  var text = item != null ? item.text : "";
  this.OnSelectionChangedCore(text, item, false);
  this.OnChange();
 },
 OnSelectionChangedCore: function(text, item, canBeRolledBack){
  this.SetTextBase(text);
  this.ShowItemImage(item);
  if(!canBeRolledBack){
   this.SetLastSuccessText(text);
   this.SetLastSuccessValue(item != null ? item.value : text);
  }
  if(this.filterStrategy) {
   if(ASPx.Browser.IE) { 
    var inputElement = this.GetInputElement();
    if(ASPx.GetActiveElement() == inputElement)
     ASPx.Selection.Set(inputElement, inputElement.value.length, inputElement.value.length);
   }
  }
 },
 ShowItemImageByIndex: function(index){
  var item = this.GetItem(index);
  this.ShowItemImage(item);
 },
 ShowCurrentItemImage: function() {
  var selectedItem = this.GetSelectedItem();
  this.ShowItemImage(selectedItem);
 },
 ShowItemImage: function(item){
  var imageUrl = item != null ? item.imageUrl : "";
  this.SetSelectedImage(imageUrl);
 },
 GetDropDownImageElement: function(){
  var itemImageCell = this.GetDropDownItemImageCell();
  if(itemImageCell != null)
   return ASPx.GetNodeByTagName(itemImageCell, "IMG", 0);
  return null;
 },
 SetSelectedImage: function(imageUrl) {
  var imgElement = this.GetDropDownImageElement();
  if(imgElement != null) {
   var imageExists = imageUrl != "";
   imageUrl = imageExists ? imageUrl : ASPx.EmptyImageUrl;
   imgElement.src = imageUrl;
   var itemImageCell = this.GetDropDownItemImageCell();
   if(ASPx.GetElementDisplay(itemImageCell) != imageExists)
    ASPx.SetElementDisplay(itemImageCell, imageExists);
   if(ASPx.Browser.IE) {
    this.AdjustControl();
   }
  }
 },
 OnCallback: function(result) {
 },
 OnChange: function(){
  this.UpdateValueInput();
  this.RaisePersonalStandardValidation();
  this.OnValueChanged();
 },
 UpdateValueInput: function() {
 },
 RaiseValueChangedEvent: function() {
  if(!this.isInitialized) return;
  var processOnServer = ASPxClientTextEdit.prototype.RaiseValueChangedEvent.call(this);
  processOnServer = this.RaiseSelectedIndexChanged(processOnServer);
  return processOnServer;
 },
 RaiseSelectedIndexChanged: function(processOnServer) {
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 GetItemHtmlContent: function(index) {
  var lb = this.GetListBoxControl();
  return lb && lb.GetItemHtmlContent(index);
 },
 AddItem: function(texts, value, imageUrl, htmlContent, cssClass, tooltip) {
  var index = this.GetListBoxControl().AddItem(texts, value, imageUrl, htmlContent, cssClass, tooltip);
  this.CollectionChanged();
  return index;
 },
 InsertItem: function(index, texts, value, imageUrl, htmlContent, cssClass, tooltip){
  this.GetListBoxControl().InsertItem(index, texts, value, imageUrl, htmlContent, cssClass, tooltip);
  this.CollectionChanged();
 },
 RemoveItem: function(index){
  this.GetListBoxControl().RemoveItem(index);
  this.CollectionChanged();
 },
 ClearItems: function(){
  this.GetListBoxControl().ClearItems();
  this.ClearItemsInternal();
 },
 BeginUpdate: function(){
   this.GetListBoxControl().BeginUpdate();
 },
 EndUpdate: function(){
  this.GetListBoxControl().EndUpdate();
  this.CollectionChanged();
 },
 MakeItemVisible: function(index){
 },
 GetItem: function(index){
  var lb = this.GetListBoxControl();
  if(lb)
   return this.GetItemCore(index);
  else
   return null;
 },
 GetItemCore: function(index) {
  return this.GetListBoxControl().GetItem(index);
 },
 FindItemByText: function(text) {
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.FindItemByText(text);
  return null;
 },
 FindItemByValue: function(value){
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.FindItemByValue(value);
  return null;
 },
 GetItemCount: function(){
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.GetItemCount(); 
  return 0;
 },
 GetSelectedIndex: function(){
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.GetSelectedIndex();
  else
   return -1;
 },
 SetSelectedIndex: function(index){
  this.SelectIndex(index, false);
 },
 GetSelectedItem: function(){
  var lb = this.GetListBoxControl();
  var index = lb.GetSelectedIndex();
  return lb.GetItem(index);
 },
 SetSelectedItem: function(item){
  var index = (item != null) ? item.index : -1;
  this.SelectIndex(index, false);
 },
 GetText: function(){
  return this.lastSuccessText;
 },
 PerformCallback: function(arg) {
 },
 ClearItemsInternal: function(){
  this.SetValue(null);
  this.CollectionChanged();
 },
 GetModifyEvent: function() {
  if(this.isNative)
   return this.SelectedIndexChanged;
  else
   return ASPxClientDropDownEditBase.prototype.GetModifyEvent.call(this);
 }
});
var ASPxClientComboBox = ASPx.CreateClass(ASPxClientComboBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.allowMultipleCallbacks = false;
  this.allowNull = false;
  this.isCallbackMode = false;
  this.loadDropDownOnDemand = false;
  this.needToLoadDropDown = false;
  this.isPerformCallback = false;
  this.changeSelectAfterCallback = 0;
  this.incrementalFilteringMode = "Contains";
  this.filterStrategy = null;
  this.filterTimer = ASPx.Browser.WebKitTouchUI ? 300 : 100; 
  this.filterMinLength = 0;
  this.customFiltering = false;
  this.initTextCorrectionRequired = false;
  this.isDropDownListStyle = true;
  this.defaultDropDownHeight = "";
  this.dropDownHeight = "";
  this.dropDownWidth = "";
  this.dropDownRows = 7;
  this.enterKeyPressed = false;
  this.onLoadDropDownOnDemandCallbackFinalizedEventHandler = null;
  this.callBackCoreComplete = false; 
  this.adroidSamsungBugTimeout = 0; 
  this.isNeedToForceFirstShowLoadingPanel = true; 
  this.forceLoadCustomRangeOnDropDown = false;
  this.needToInitPopupWindowOnShow = false;
  this.ItemFiltering = new ASPxClientEvent();
  this.CustomHighlighting = new ASPxClientEvent();
 },
 Initialize: function(){
  this.needToLoadDropDown = this.loadDropDownOnDemand;
  var lb = this.GetListBoxControl();
  this.InitializeListBoxOwnerName();
  this.InitScrollSpacerVisibility();
  this.InitializeFilterStrategy();
  var mainElement = this.GetMainElement();
  var input = this.GetInputElement();    
  var ddbutton = this.GetDropDownButton();
  ASPx.Evt.AttachEventToElement(input, "paste", this.SyncRawValueIfHasTextDecorators.bind(this, true));
  if(this.isDropDownListStyle && (ASPx.Browser.IE || (ASPx.Browser.WindowsPlatform && ASPx.Browser.Safari))) {
   ASPx.Evt.AttachEventToElement(this.GetInputElement(), "blur", function() {
    var inputElementValue = this.GetInputElement().value;
    if(!this.focusEventsLocked && !inputElementValue && !!this.GetText())
     this.OnTextChanged();
   }.aspxBind(this)); 
   if(ASPx.Browser.IE) {
    ASPx.Evt.PreventElementDragAndSelect(mainElement, true, true);
    ASPx.Evt.PreventElementDragAndSelect(input, true, true);
    if(ddbutton)
     ASPx.Evt.PreventElementDragAndSelect(ddbutton, true);
   }
  }
  if(this.isToolbarItem){
   if(ASPx.Browser.IE && ASPx.Browser.Version == 9)
    input.onmousedown = function(evt) { ASPx.Evt.PreventEvent(evt); };
   else {
    mainElement.unselectable="on";
    input.unselectable="on";
    if(input.offsetParent)
     input.offsetParent.unselectable="on";
    if(ddbutton)
     ddbutton.unselectable="on";
    if(lb)
     lb.SetItemRowsUnselectable();
   }
  }
  this.RemoveRaisePSValidationFromListBox();
  this.RedirectStandardValidators();
  if(lb && lb.GetItemCount() > 0)
   this.EnsureListBoxSelectionSynchronized(lb);
  ASPxClientComboBoxBase.prototype.Initialize.call(this);
 },
 InitScrollSpacerVisibility: function() {
  var lb = this.GetListBoxControl();
  if(!lb || lb.GetItemCount() >= lb.callbackPageSize)
   return;
  lb.SetScrollSpacerVisibility(true, false);
  lb.SetScrollSpacerVisibility(false, false);
 },
 InitializeFilterStrategy: function() {
  var fs = this.filterStrategy;
  ASPx.Evt.AttachEventToElement(this.GetInputElement(), "keydown", fs.OnKeyDown.bind(fs));
 },
 CreateFilterStrategy: function() {
  if(this.incrementalFilteringMode == "Contains")
   return new ComboBoxContainsFilterStrategy(this);
  else if(this.incrementalFilteringMode == "StartsWith")
   return new ComboBoxStartsWithFilterStrategy(this);
  else if(this.incrementalFilteringMode == "None")
   return new ComboBoxDisabledFilterStrategy(this);
 },
 shouldStartUserInputTimer: function() {
  return true;
 },
 onInputChangedOnUserInputTimer: function(onRestart) {
  ASPxClientDropDownEditBase.prototype.onInputChangedOnUserInputTimer.call(this);
  if (!onRestart) {
   this.SyncRawValueIfHasTextDecorators();
   this.filterStrategy.OnInput();
  }
 },
 RaiseItemFiltering: function(item, filter, isFit) {
  if(!this.ItemFiltering.IsEmpty()) {
   var args = new ASPxClientListEditItemFilteringEventArgs(item, filter, isFit);
   this.ItemFiltering.FireEvent(this, args);
   isFit = args.isFit;
  }
  return isFit;
 },
 RaiseCustomHighlighting: function(filter, callbackHighlighting) {
  if(!this.CustomHighlighting.IsEmpty()) {
   var args = new ASPxClientListEditCustomHighlightingEventArgs(filter);
   args.highlighting = callbackHighlighting;
   this.CustomHighlighting.FireEvent(this, args);
   return args.highlighting;
  }
  return callbackHighlighting;
 },
 InlineInitialize: function() {
  this.BeforeInlineInitialize();
  this.filterStrategy = this.CreateFilterStrategy();
  this.InitSpecialKeyboardHandling();
  ASPxClientComboBoxBase.prototype.InlineInitialize.call(this);
 },
 IsClearButtonVisibleAuto: function() {
  return this.allowNull && ASPxClientComboBoxBase.prototype.IsClearButtonVisibleAuto.call(this);
 },
 BeforeInlineInitialize: function() {
  this.lastSuccessValue = this.GetDecodeValue(this.lastSuccessValue);
  this.InsureInputValueCorrect();
 },
 InsureInputValueCorrect: function(){ 
  if(this.initTextCorrectionRequired){
   var lb = this.GetListBoxControl();
   if(lb){
    var initSelectedIndex = lb.GetSelectedIndexInternal();
    if(initSelectedIndex >= 0){
     var initSelectedText = lb.GetItem(initSelectedIndex).text;
     var input = this.GetInputElement();
     if(ASPx.IsExists(this.GetRawValue()) && this.GetRawValue() != initSelectedText){
      this.SetRawValue(initSelectedText);
      this.SetInputValue(this.GetDecoratedText(initSelectedText));
     } 
     else if(input.value != initSelectedText)
      this.SetInputValue(initSelectedText);
    }
   }
  }
 },
 ChangeEnabledAttributes: function(enabled){
  ASPxClientComboBoxBase.prototype.ChangeEnabledAttributes.call(this, enabled);
  var changeEventsMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  var mainElement = this.GetMainElement();
  if(mainElement)
   changeEventsMethod(mainElement, ASPx.Evt.GetMouseWheelEventName(), aspxCBMouseWheel);
  var btnElement = this.GetDropDownButton();
  if(btnElement)
   changeEventsMethod(btnElement, "onmousemove", ASPx.CBDDButtonMMove);
 },
 GetDropDownInnerControlName: function(suffix){
  return ASPxClientDropDownEditBase.prototype.GetDropDownInnerControlName.call(this, suffix);
 },
 AdjustControlCore: function() {
  ASPxClientEdit.prototype.AdjustControlCore.call(this);
  this.ResetDropDownSizeCache();
 },
 RemoveRaisePSValidationFromListBox: function() {
  var listBox = this.GetListBoxControl();
  if(listBox)
   listBox.RaisePersonalStandardValidation = function() { };
 },
 RedirectStandardValidators: function() {
  var valueInput = this.GetValueInput();
  if(ASPx.IsExistsElement(valueInput) && valueInput.Validators) {
   for(var i = 0; i < valueInput.Validators.length; i++)
    valueInput.Validators[i].controltovalidate = valueInput.id;
  }
 },
 GetValueInputToValidate: function(){
  return this.GetValueInput();
 },
 SetText: function(text, applyFilter) {
  ASPxClientComboBoxBase.prototype.SetText.call(this, text);
  if(applyFilter)
   this.filterStrategy.Filtering(true);
 },
 SetTextBase: function(text) {
  ASPxClientComboBoxBase.prototype.SetTextBase.call(this, text);
  this.restartCurrentUserInputTimer();
 },
 GetValueInput: function(){
  return document.getElementById(this.name + "_" + comboBoxValueInputSuffix);
 },
 GetListBoxScrollDivElement: function(){
  return this.GetListBoxControl().GetScrollDivElement();
 },
 RollbackValueInputValue: function(){
  var inputElement = this.GetValueInput();
  if(inputElement)
   inputElement.value = this.lastSuccessValue;
 },
 UpdateValueInput: function() {
  var inputElement = this.GetValueInput();
  if(inputElement) {
   var value = this.GetValue();
   inputElement.value = value != null ? value : "";
  }
 },
 SetInputValue: function(value) {
  var inputElement = this.GetInputElement();
  if(inputElement) {
   inputElement.value = value;
   this.restartCurrentUserInputTimer();
  }
 },
 CollectionChanged: function(filtering){
  this.GetSetValueOptimizeHelper().onItemCollectionChanged();
  var listBox = this.GetListBoxControl();
  listBox.CollectionChanged(filtering);
  var needUpdateDropDownPositionAndSize = listBox.APILockCount == 0 && (this.isShownAtFirst || filtering);
  if(needUpdateDropDownPositionAndSize)
   this.UpdateDropDownPositionAndSize();
 },
 UpdateDropDownPositionAndSize: function(){
  this.InitDropDownSize();
  if(this.droppedDown){
   var pc = this.GetPopupControl();
   var element = this.GetMainElement();
   pc.UpdatePositionAtElement(element);
  }
  if(!this.clientVisible)
   this.ResetControlAdjustment();
 },
 GetDropDownHeight: function(){
  if(this.ddHeightCache != ASPx.InvalidDimension)
   return this.ddHeightCache;
  this.EnsureDropDownWidth(); 
  return this.AdjustListBoxHeight();
 },
 GetDropDownWidth: function(){
  return (this.ddWidthCache != ASPx.InvalidDimension && !this.GetIsControlWidthWasChanged()) ? this.ddWidthCache : this.AdjustListBoxWidth();
 },
 EnsureDropDownWidth: function() {
  this.GetDropDownWidth();
 },
 InitDropDownSize: function() {
  if(!this.enabled || this.GetItemCount() == 0) return; 
  var pc = this.GetPopupControl();
  if(pc && this.IsDisplayed() && !this.IsHidden()) {
   var pcwElement = pc.GetCurrentWindowElement();
   if(ASPx.IsExistsElement(pcwElement)){
    var isPcwDisplayed = ASPx.GetElementDisplay(pcwElement);
    if(!isPcwDisplayed)
     pc.SetWindowDisplay(-1, true);
    var listBoxHeight = this.AdjustListBoxHeight();
    var listBoxWidth = this.AdjustListBoxWidth();
    if(listBoxHeight != this.ddHeightCache || listBoxWidth != this.ddWidthCache){
     this.ddHeightCache = listBoxHeight;
     this.ddWidthCache = listBoxWidth;
     pc.SetSize(this.ddWidthCache, this.ddHeightCache);
    }
    if(!isPcwDisplayed)
     pc.SetWindowDisplay(-1, false);
   }
  } else {
   this.needToInitPopupWindowOnShow = true;
  }
 },
 InitMainElementCache: function(){
  this.mainElementWidthCache = this.GetMainElement().clientWidth;
 },
 GetDefaultDropDownHeight: function(listHeight, count){
  if(this.defaultDropDownHeight == ""){
   this.defaultDropDownHeight = ((listHeight / count) * this.dropDownRows) + "px";
  }
  return this.defaultDropDownHeight;
 },
 AdjustListBoxHeight: function () {
  return this.GetListBoxControl().AdjustHeightInDropDown(this.dropDownHeight, this.dropDownRows, this.GetDefaultDropDownHeight.aspxBind(this));
 },
 AdjustListBoxWidth: function () {
  this.InitMainElementCache();
  return this.GetListBoxControl().AdjustWidthInDropDown(this.GetMainElement(), this.isCallbackMode, this.dropDownWidth);
 },
 SelectIndexSilent: function(lb, index, lockScrollingToItem){
  this.lbEventLockCount ++;
  lb.SelectIndexSilentAndMakeVisible(index, lockScrollingToItem);
  this.ShowItemImageByIndex(index);
  this.lbEventLockCount --;
 },
 GetDecoratedText: function(text) {
  var result;
  var lb = this.GetListBoxControl();
  var hasMultiColumnFormattedSelectedItem = this.displayFormat != null &&
              lb && lb.IsMultiColumn() &&
              this.GetSelectedItem() != null;
  if(hasMultiColumnFormattedSelectedItem)
   result = this.GetMultiColumnFormattedSelectedItemText(lb);
  else
   result = ASPxClientComboBoxBase.prototype.GetDecoratedText.call(this, text);
  return result;
 },
 GetMultiColumnFormattedSelectedItemText: function(lb) {
  var selectedItem = this.GetSelectedItem();
  var textColumnCount = this.GetTextColumnCountForTextDecoration(lb, selectedItem);
  var texts = [textColumnCount];
  for(var i = 0; i < textColumnCount; i++)
   texts[i] = selectedItem.GetColumnTextByIndex(i);
  return ASPx.Formatter.Format(this.displayFormat, texts);
 },
 GetTextColumnCountForTextDecoration: function(lb, item) {
  return lb.GetItemTextCellCount();
 },
 CanApplyNullTextDecoration: function() {
  var result;
  if(this.GetListBoxControl() || !this.loadDropDownOnDemand) {
   var value = this.isInitialized ? this.GetRawValue() : this.GetValue();
   var isValueNull = this.convertEmptyStringToNull && value === "" ? true : value === null;
   result = this.GetSelectedIndex() == -1 && isValueNull;
  } else
   result = this.GetCurrentText() === "";
  return result;
 },
 ForceTextChanged: function() {
  if(this.isCallbackMode && this.filterStrategy)
   this.filterStrategy.ClearFilterApplied();
  ASPxClientComboBoxBase.prototype.ForceTextChanged.call(this);
 },
 ShowDropDownArea: function(isRaiseEvent){
  if(this.needToLoadDropDown) {
   this.EnsureDropDownLoaded();
   return;
  }
  if(this.RequireLoadCustomRangeOnDropDown()){
   this.LoadCustomItemsRange();
   return;
  }
  var lb = this.GetListBoxControl();
  if(!lb || (!this.isDropDownModal() && !lb.GetItemCount()))
   return;
  if(!this.filterStrategy.IsFilterMeetRequirementForMinLength() && !this.isDropDownModal()) {
   this.DropDownButtonPop(true); 
   return;
  }
  if(this.needToInitPopupWindowOnShow) {
   this.needToInitPopupWindowOnShow = false;
   this.InitDropDownSize();
  }
  ASPxClientDropDownEditBase.prototype.ShowDropDownArea.call(this, isRaiseEvent);
  this.EnsureListBoxSelectionSynchronized(lb);
  this.EnsureSelectedItemVisibleOnShow(lb);
  lb.CallbackSpaceInit();
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetExpandedState(true);
  if(!lb.GetItemCount())
   this.onNoResultsFiltering();
  if(!this.filterStrategy.IsFilterMeetRequirementForMinLength())
   this.onProcessFilterLessMinLength();
 },
 ForceShowLoadingPanel: function() {
  if(this.GetItemCount() == 0 && !this.needToLoadDropDown) {
   var lb = this.GetListBoxControl();
   if(lb) {
    var sizes = { width: this.GetWidth(), height: 100 };
    ASPxClientDropDownEditBase.prototype.ShowDropDownArea.call(this, false, sizes);
    lb.SetHeight(sizes.height);
    lb.SetWidth(sizes.width);
   }
  }
 },
 FireFoxRequiresCacheScrollBar: function(){
  return ASPx.Browser.Firefox && ASPx.Browser.Version >= 3.6; 
 },
 BrowserRequiresCacheScrollBar: function(){
  return ASPx.Browser.WebKitFamily || ASPx.Browser.Opera || this.FireFoxRequiresCacheScrollBar(); 
 },
 HideDropDownArea: function(isRaiseEvent){
  if(this.filterStrategy)
   this.filterStrategy.OnDropDownHideArea();
  if(this.BrowserRequiresCacheScrollBar())
   this.CachedScrollTop();
  ASPxClientDropDownEditBase.prototype.HideDropDownArea.call(this, isRaiseEvent);
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetExpandedState(false);
 },
 EnsureSelectedItemTextSynchronized: function(){
  var selectedItem = this.GetSelectedItem();
  if(!this.CanSynchronizeSelectedItemText(selectedItem))
   return;
  var textUnsynchronized = this.GetText() !== selectedItem.text;
  var textDecorationUnsynchronized = this.HasTextDecorators() && this.CanApplyTextDecorators() && 
   this.GetDecoratedText(selectedItem.text) !== this.GetInputElement().value; 
  if(textUnsynchronized || textDecorationUnsynchronized || !this.IsImageSynchronized(selectedItem)) {
   this.SetTextBase(selectedItem.text);
   this.ShowItemImage(selectedItem);
   this.SetLastSuccessText(selectedItem.text);
   this.UpdateValueInput();
  }
 },
 IsImageSynchronized: function(selectedItem) {
  var ddImageElement = this.GetDropDownImageElement();
  var imageUrl = selectedItem.imageUrl != "" ? selectedItem.imageUrl : ASPx.Url.GetAbsoluteUrl(ASPx.EmptyImageUrl);
  return !ddImageElement || ASPx.ImageUtils.GetImageSrc(ddImageElement) === imageUrl;
 },
 CanSynchronizeSelectedItemText: function(selectedItem) {
  return !!selectedItem;
 },
 EnsureListBoxSelectionSynchronized: function(listBox){
  var rawText = this.GetTextInternal();
  var lbItem = listBox.GetSelectedItem();
  var lbText = lbItem != null ? lbItem.text : "";
  var isTextsExist = rawText != null && lbText != "";
  var needSynchronize = rawText != lbText || !this.isInitialized;
  if(needSynchronize && isTextsExist) {
   this.SynchronizeListBoxSelection(listBox, rawText);
   if(!this.isInitialized && this.IsValueRestoredByBrowser())
    this.SynchronizeListBoxInitSelection();
  }
 },
 SynchronizeListBoxSelection: function(listBox, rawText) {
  var newSelectedIndex = this.GetAdjustedSelectedIndexByText(listBox, rawText);
  listBox.SelectIndexSilent(newSelectedIndex, false);
 },
 SynchronizeListBoxInitSelection: function() {
  setTimeout(function () {
   var inputText = this.GetInputElement().value;
   var selectedItem = this.FindItemByText(inputText);
   if(selectedItem)
    this.SelectIndex(selectedItem.index, true);
  }.aspxBind(this), 0);
 },
 EnsureSelectedItemVisibleOnShow: function(listBox){
  if(this.BrowserRequiresCacheScrollBar()) 
   listBox.RestoreScrollTopFromCache();
  listBox.EnsureSelectedItemVisible();
 },
 CachedScrollTop: function(){
  this.GetListBoxControl().CachedScrollTop();
  if(this.BrowserRequiresCacheScrollBar()){ 
   var scrollDiv = this.GetListBoxScrollDivElement();
   if(scrollDiv != null)
    scrollDiv.scrollTop = 0;
  }
 },
 IsFilterEnabled: function() {
  return this.incrementalFilteringMode != "None";
 },
 ChangeInputEnabled: function(element, enabled, readOnly){
  ASPxClientTextEdit.prototype.ChangeInputEnabled.call(this, element, enabled, readOnly || (this.isDropDownListStyle && !this.IsFilterEnabled()));
 },
 GetCallbackArguments: function(){
  var args = ASPxClientComboBoxBase.prototype.GetCallbackArguments.call(this);
  args += this.filterStrategy.GetCallbackArguments();
  return args;
 },
 ClearEditorValueByClearButtonCore: function() {
  this.enterKeyPressed = false;
  ASPxClientDropDownEditBase.prototype.ClearEditorValueByClearButtonCore.call(this);
  if(!this.IsFilterEnabled() && this.isDropDownListStyle)
   this.HideDropDownArea();
  else
   this.filterStrategy.OnClearButtonClick();
 },
 ResetEditorState: function() {
  ASPxClientComboBoxBase.prototype.ResetEditorState.call(this);
  this.isNeedToForceFirstShowLoadingPanel = true;
  this.filterStrategy.ResetCallbackState();
 },
 IsFilterRollbackRequiredAfterApply: function() {
  var filterRollbackRequired = !this.GetSelectedItem() && !this.focused && this.InCallback();
  return filterRollbackRequired;
 },
 IsNullState: function() {
  return this.GetSelectedIndex() === -1 && ASPxClientComboBoxBase.prototype.IsNullState.call(this);
 },
 OnPost: function(args) {
  if(!args.isCallback && this.isDropDownListStyle && ASPx.GetFocusedElement() == this.GetInputElement())
   this.OnTextChangedInternal();
  ASPxClientComboBoxBase.prototype.OnPost.call(this, args);
 },
 GetLoadingParentElement: function(listBox) {
  return listBox.GetLoadingParentElement();
 },
 ShowLoadingPanel: function() { 
  var lb = this.GetListBoxControl();
  var loadingParentElement = this.GetLoadingParentElement(lb);
  if(!this.loadingPanelElement) {
   var loadingPanel = this.CreateLoadingPanelWithAbsolutePosition(loadingParentElement, loadingParentElement);
   lb.PreventMouseWheelOnElement(loadingPanel); 
  }
 },
 ShowLoadingDiv: function () {
  var lb = this.GetListBoxControl();
  var loadingParentElement = this.GetLoadingParentElement(lb);
  if(!this.loadingDivElement) {
   var loadingDiv = this.CreateLoadingDiv(loadingParentElement);
   lb.PreventMouseWheelOnElement(loadingDiv);
  }
 },
 HideLoadingPanelOnCallback: function(){
  return false;
 },
 OnCallback: function(result, callbackID) {
  if(!this.CanProcessCallbackResult(callbackID))
   return;
  this.defaultDropDownHeight = "";
  if(ASPx.Browser.WebKitTouchUI) { 
   if(this.needToLoadDropDown)
    this.OnLoadDropDownOnDemandCallback(result.c);
   window.setTimeout(function() {
    this.OnCallbackCore(result);
    this.DoEndCallback();
   }.aspxBind(this), 300);
  } else
   this.OnCallbackCore(result);
 },
 OnCallbackCore: function(result) {
  if(result.serverMode)
   this.UpdateStateObjectWithObject({serverMode: true});
  if(this.needToLoadDropDown) {
   if(!ASPx.Browser.WebKitTouchUI)
    this.OnLoadDropDownOnDemandCallback(result.c);
  } else if(!this.filterStrategy.ShouldDiscardCallbackResult()) {
   this.OnCallbackBeforeListBox();
   this.OnListBoxCallback(result);
   this.OnCallbackInternal(result);
   this.OnCallbackFinally(true);
  }
  this.callBackCoreComplete = true;
 },
 OnListBoxCallback: function(result) {
  var selectedValue = this.GetValue();
  var selectedText = this.GetText();
  function shouldSelectSilent(value, text) {
   return value === selectedValue || text === selectedText;
  }
  this.GetListBoxControl().OnCallback(result, shouldSelectSilent);
  this.EnsureSelectedItemTextSynchronized();
 },
 OnLoadDropDownOnDemandCallbackFinalized: function() {
  this.DoReInitializeAfterLoadDropDownOnDemand();
  this.HideLoadingPanel();
  this.HideLoadingDiv();
  var isCallbackForShowDropDownArea = !this.onLoadDropDownOnDemandCallbackFinalizedEventHandler;
  if(isCallbackForShowDropDownArea) {
   this.ShowDropDown();
   if(this.isDropDownModal())
    this.onDropDownModalChanged(true);
  }
  else
   this.onLoadDropDownOnDemandCallbackFinalizedEventHandler();
  this.FixButtonState();
  this.initializeDropDown();
 },
 OnCallbackFinalized: function() {
  if(this.needToLoadDropDown)
   this.OnLoadDropDownOnDemandCallbackFinalized();
 },
 OnLoadDropDownOnDemandCallback: function(html) {
  var node = this.GetLoadedDropDownPrevSibling();
  var tempDiv = node.ownerDocument.createElement('div');
  tempDiv.innerHTML = html;
  var len = tempDiv.childNodes.length;
  for(var ind = len - 1; ind >= 0; ind--) {
   ASPx.InsertElementAfter(tempDiv.childNodes.item(ind), node);
  }
 },
 GetLoadedDropDownPrevSibling: function() {
  return this.GetMainElement();
 },
 ProcessCallbackError: function(errorObj, callbackID) {
  if(!this.CanProcessCallbackResult(callbackID))
   return;
  this.callBackCoreComplete = true;
  ASPxClientDropDownEditBase.prototype.ProcessCallbackError.call(this, errorObj);
 },
 DoEndCallback: function(){ 
  if(!this.callBackCoreComplete && ASPx.Browser.WebKitTouchUI || this.IsDoEndCallbackLocked()) {
   this.UnlockDoEndCallback();
   return;
  }
  this.filterStrategy.OnBeforeDoEndCallback();
  ASPxClientDropDownEditBase.prototype.DoEndCallback.call(this);
  this.filterStrategy.OnAfterDoEndCallback();
  this.callBackCoreComplete = false; 
 },
 RaiseEndCallback: function(){
  if(this.preventEndCallbackRising) {
   this.preventEndCallbackRising = false;
   ASPx.GetControlCollection().DecrementRequestCount(); 
  } else {
   ASPxClientDropDownEditBase.prototype.RaiseEndCallback.call(this);
  }
 },
 OnCallbackError: function(result, data) {
  var lb = this.GetListBoxControl();
  if(lb)
   lb.OnCallbackError(result);
  else
   ASPxClientComboBoxBase.prototype.OnCallbackError.call(this, result, data);
  this.OnCallbackFinally(false);
 },
 OnCallbackFinally: function(isSuccessful){
  this.filterStrategy.OnBeforeCallbackFinally();
  this.CollectionChanged();
  this.HideLoadingElements();
  if(this.isNeedToForceFirstShowLoadingPanel)
   this.isNeedToForceFirstShowLoadingPanel = false;
  this.isPerformCallback = false;
  this.changeSelectAfterCallback = 0;
  if(isSuccessful)
   this.filterStrategy.OnAfterCallbackFinally();
 },
 OnCallbackBeforeListBox: function(){
  var lb = this.GetListBoxControl();
  this.changeSelectAfterCallback = lb.changeSelectAfterCallback;
 },
 OnCallbackCorrectSelectedIndex: function(){
  var lb = this.GetListBoxControl();
  if(this.changeSelectAfterCallback != 0)
   this.SetTextInternal(lb.GetSelectedItem().text);
 },
 OnCallbackInternal: function(result){
  this.OnCallbackCorrectSelectedIndex();
  if(this.isPerformCallback) {
   var lb = this.GetListBoxControl();
   if(!lb.GetItemCount()) {
    this.onNoResultsFiltering();
    if(!this.isDropDownModal())
     this.HideDropDownArea(true);
   }
  }
  this.filterStrategy.OnCallback(result);
 },
 DoReInitializeAfterLoadDropDownOnDemand: function() {
  this.InitializeListBoxOwnerName();
  this.needToLoadDropDown = false;
 },
 CancelLoadCustomRangeOnDropDown: function() {
  delete this.customItemsRangeInfo;
 },
 ForceLoadCustomItemsRangeOnDropDown: function(startIndex, valueToSelect) {
  var count = this.GetListBoxControl().callbackPageSize;
  this.customItemsRangeInfo = { startIndex: startIndex, endIndex: startIndex + count - 1, valueToSelect: valueToSelect };
 },
 RequireLoadCustomRangeOnDropDown: function() { return !!this.customItemsRangeInfo; },
 LoadCustomItemsRange: function() {
  if(this.InCallback()) return;
  this.ClearItems();
  this.ShowInputLoadingPanel();
  var startIndex = this.customItemsRangeInfo.startIndex;
  var endIndex = this.customItemsRangeInfo.endIndex;
  var value = this.customItemsRangeInfo.valueToSelect;
  var callbackArgs = this.GetListBoxControl().GetLoadCustomItemsRangeCallbackArguments(startIndex, endIndex, value);
  this.SendSpecialCallback(callbackArgs, function() { this.OnSuccessCustomItemsRangeLoad(); }.aspxBind(this));
 },
 OnSuccessCustomItemsRangeLoad: function() {
  var info = this.customItemsRangeInfo;
  if(!info) return;
  var listBox = this.GetListBoxControl();
  var startIndex = info.startIndex;
  listBox.serverIndexOfFirstItem = startIndex;
  listBox.SetScrollSpacerVisibility(true, startIndex > 0);
  if(ASPx.IsExists(info.valueToSelect))
   this.SetValue(info.valueToSelect);
  this.CancelLoadCustomRangeOnDropDown();
  this.ShowDropDown();
 },
 EnsureDropDownLoaded: function(callbackFunction) {
  if(this.needToLoadDropDown) {
   this.onLoadDropDownOnDemandCallbackFinalizedEventHandler = callbackFunction ? function() {
    callbackFunction();
   } : null;
   var args = this.FormatLoadDropDownOnDemandCallbackArguments();
   this.SendLoadDropDownOnDemandCallback(args);
  }
 },
 IsDropDownButtonClick: function(evt) {
  return ASPx.GetIsParent(this.GetDropDownButton(), ASPx.Evt.GetEventSource(evt));
 },
 OnDropDown: function(evt) {
  var returnValue = ASPxClientDropDownEditBase.prototype.OnDropDown.call(this, evt);
  if(this.IsDropDownButtonClick(evt) && this.IsCanToDropDown()) {
   this.OnDropDownButtonClick(evt);
   return returnValue;
  }
  return true;
 },
 OnDropDownButtonClick: function(evt) {
  if(this.filterStrategy != null)
   this.filterStrategy.OnDropDownButtonClick();     
  this.ForceRefocusEditor(evt);
 },
 SendCallback: function(onSuccess){
  if(!this.pcIsShowingNow)
   this.ShowLoadingElements();
  ASPxClientComboBoxBase.prototype.SendCallback.call(this, onSuccess);
 },
 IsAndroidKeyEventsLocked: function() {
  return ASPx.Browser.AndroidMobilePlatform && this.androidKeyEventsLocked;
 },
 LockAndroidKeyEvents: function() {
  this.androidKeyEventsLocked = true;
 },
 UnlockAndroidKeyEvents: function() {
  this.androidKeyEventsLocked = false;
 },
 CancelChangesOnUndo: function() {
  if(this.isCallbackMode)
   this.SetTextInternal(this.lastSuccessText);
  else
   this.OnCancelChanges();
  this.filterStrategy.OnUndo();
 },
 OnKeyDown: function(evt) {
  if(this.IsCtrlZ(evt)) {
   this.CancelChangesOnUndo();
   return ASPx.Evt.PreventEvent(evt);
  }
  var isClearKey = ASPx.Data.ArrayIndexOf([ASPx.Key.Delete, ASPx.Key.Backspace], evt.keyCode) >= 0;
  if(isClearKey && this.allowNull && (this.IsAllTextSelected() || this.isDropDownListStyle && !this.IsFilterEnabled()))
   this.ClearEditorValueAndForceOnChange();
  else if(this.IsAndroidKeyEventsLocked())
   return ASPx.Evt.PreventEventAndBubble(evt);
  else
   ASPxClientComboBoxBase.prototype.OnKeyDown.call(this, evt);
 },
 OnKeyUp: function(evt) {
  if(this.IsAndroidKeyEventsLocked())
   return ASPx.Evt.PreventEventAndBubble(evt);
  return ASPxClientComboBoxBase.prototype.OnKeyUp.call(this, evt);
 },
 IsAllTextSelected: function() {
  var input = this.GetInputElement();
  var textLength = input.value.length;
  if(textLength === 0)
   return false;
  var selectionInfo = ASPx.Selection.GetExtInfo(input);
  var selectionLength = selectionInfo.endPos - selectionInfo.startPos;
  return selectionLength === textLength;
 },
 SelectNeighbour: function (step){
  if((this.isToolBarItem && !this.droppedDown) || this.GetReadOnly()) return;
  this.SelectNeighbourInternal(step);
 },
 SelectNeighbourInternal: function(step){
  var lb = this.GetListBoxControl();
  if(this.droppedDown)
   this.lbEventLockCount ++;
  lb.SelectNeighbour(step);
  if(this.droppedDown) {
   var selectedItem = lb.GetSelectedItem();
   if (selectedItem) {
    this.OnSelectionChangedCore(selectedItem.text, selectedItem, true);
   }
   this.lbEventLockCount --;
  }
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetLabelAttribute(null, null);
 },
 GetFocusSelectAction: function() {
  return (this.isToolbarItem || ASPx.Browser.IE && this.refocusWhenInputClicked) ? null : "all";
 },
 OnArrowUp: function(evt){
  if(!this.isInitialized) return true;
  if(this.RequireLoadCustomRangeOnDropDown() && !this.droppedDown) {
   this.LoadCustomItemsRange();
   return;
  }
  var isProcessed = ASPxClientDropDownEditBase.prototype.OnArrowUp.call(this, evt);
  if(!isProcessed && this.filterStrategy.CanNavigateByKbd())
   this.SelectNeighbour(-1);
  return true;
 },
 OnTextChanged: function(){
  if(!this.IsFocusEventsLocked())
   ASPxClientComboBoxBase.prototype.OnTextChanged.call(this);
 },
 OnTextChangedInternal: function() {
  if(!this.forceValueChanged) {
   var preserveFilterInInput = this.InCallback() && this.filterStrategy.currentCallbackIsFiltration;
   if(preserveFilterInInput) return;
  }
  ASPxClientComboBoxBase.prototype.OnTextChangedInternal.call(this);
  if(this.filterStrategy)
   this.filterStrategy.OnTextChanged();
 },
 OnArrowDown: function(evt){
  if(!this.isInitialized) return true;
  if(this.RequireLoadCustomRangeOnDropDown() && !this.droppedDown) {
   this.LoadCustomItemsRange();
   return;
  }
  var isProcessed = ASPxClientDropDownEditBase.prototype.OnArrowDown.call(this, evt);
  if(!isProcessed && this.filterStrategy.CanNavigateByKbd())
   this.SelectNeighbour(1);
  return true;
 },
 OnPageUp: function(){
  if(!this.isInitialized || !this.filterStrategy.CanNavigateByKbd()) return true;
  return this.OnPageButtonDown(false);
 },
 OnPageDown: function(){
  if(!this.isInitialized || !this.filterStrategy.CanNavigateByKbd()) return true;
  return this.OnPageButtonDown(true);
 },
 OnPageButtonDown: function(isDown){
  if(!this.isInitialized) return true;
  var lb = this.GetListBoxControl();
  if(lb){
   var direction = isDown ? 1 : -1;
   this.SelectNeighbour(lb.scrollPageSize * direction);
  }
  return true;
 },
 OnHomeKeyDown: function(evt){
  if(!this.isInitialized) return true;
  return this.OnHomeEndKeyDown(evt, true);
 },
 OnEndKeyDown: function(evt){
  if(!this.isInitialized) return true;
  return this.OnHomeEndKeyDown(evt, false);
 },
 OnHomeEndKeyDown: function(evt, isHome){
  if(!this.isInitialized) return true;
  var input = this.GetValueInput();
  if((input && input.readOnly) || evt.ctrlKey){
   var lb = this.GetListBoxControl();
   var count = lb.GetItemCount();
   this.SelectNeighbour(isHome ? -count : count);
   return true;
  }
  return false;
 },
 OnEscape: function() {
  this.filterStrategy.OnEscape();
  return ASPxClientComboBoxBase.prototype.OnEscape.call(this);
 },
 OnEnter: function(){
  if(!this.isInitialized) return true;
  if(this.isDropDownListStyle) this.enterKeyPressed = true;
  if(this.filterStrategy.IsCloseByEnterLocked()) return;
  this.enterProcessed = this.droppedDown; 
  if(!this.isEnterLocked) { 
   this.OnApplyChangesAndCloseWithEvents();
   this.filterStrategy.OnAfterEnter();
  }
  return this.enterProcessed;
 },
 OnTab: function(evt){
  if(!this.isInitialized) 
   return true;
  if(this.InCallback())
   this.filterStrategy.callbackProcessingStateManager.SetApply();
  else
   this.OnApplyChangesAndCloseWithEvents();
 },
 OnApplyChanges: function(){
  if(!this.focused || (this.isDropDownListStyle && !this.IsFilterEnabled())) return;
  this.OnApplyChangesInternal();
 },
 OnApplyChangesAndCloseWithEvents: function() {
  this.OnApplyChangesInternal();
  this.HideDropDownArea(true);
 },
 OnApplyChangesInternal: function(){
  var inCallback = this.InCallback();
  var lb = this.GetListBoxControl();
  var isChanged = this.HasChanges();
  var isRollback = false;
  if(isChanged || this.filterStrategy.isTotallyMismatchedFilter) {
   this.filterStrategy.isTotallyMismatchedFilter = false;
   this.filterStrategy.needEmptyFilterBeforeFiltering = false;
   var text = this.GetCurrentText();
   if(this.filterStrategy.OnApplyChanges())
    return;
   var adjustedSelectedIndex = this.GetAdjustedSelectedIndexByText(lb, text);
   var isNullState = this.allowNull && !text;
   var rollbackRequired = this.isDropDownListStyle && adjustedSelectedIndex < 0 && !isNullState;
   if(rollbackRequired) {
    var rollbackToItem = lb.GetSelectedItem();
    isRollback = rollbackToItem == null && this.isCallbackMode; 
    if(isRollback) {
     this.RollbackValueInputValue();
     this.RollbackTextInputValue();
    }
    text = rollbackToItem != null ? rollbackToItem.text : this.lastSuccessText;
   } 
   if(!isRollback) {
    var adjustedSelectedItem = this.GetItem(adjustedSelectedIndex);
    var adjustedSelectedItemText = adjustedSelectedItem && adjustedSelectedItem.text;
    text = adjustedSelectedItemText || text;
    var hasChanges = this.HasChanges(text);
    this.SetText(text);
    if(hasChanges)
     this.OnChange();
   }
   else if(!inCallback) {
    this.filterStrategy.OnFilterRollback();
   }
  } 
 },
 GetCurrentText: function(){
  var textDecorated = !this.focused && this.GetRawValue() != null;
  return textDecorated ? this.GetRawValue() : this.GetInputElement().value;
 },
 GetCurrentValue: function(){
  var value = null;
  var selectedItem = this.listBox.GetSelectedItem();
  if(selectedItem && (selectedItem.value !== "" || !this.convertEmptyStringToNull))
   value = selectedItem.value;
  return selectedItem ? value : this.GetValue();
 },
 HasChanges: function(currentText){
  currentText = currentText === undefined ? this.GetCurrentText() : currentText;
  return this.lastSuccessText != currentText || this.lastSuccessValue != this.GetCurrentValue();
 },
 OnButtonClick: function(number){
  if(number != this.dropDownButtonIndex) {
   if(this.droppedDown)
    this.OnApplyChangesAndCloseWithEvents(false);
   else
    ASPxClientComboBoxBase.prototype.OnTextChanged.call(this);
  }
  ASPxClientButtonEditBase.prototype.OnButtonClick.call(this, number);
 },
 OnCancelChanges: function(){
  var isCancelProcessed = ASPxClientDropDownEditBase.prototype.OnCancelChanges.call(this);
  this.filterStrategy.OnCancelChanges();
  var lb = this.GetListBoxControl();
  if(ASPx.IsExists(lb)) {
   var index = this.GetAdjustedSelectedIndexByText(lb, this.lastSuccessText);
   this.SelectIndexSilent(lb, index);
  }
  return isCancelProcessed;
 },
 ShouldCloseOnMCMouseDown: function () {
  return this.GetInputElement().readOnly;
 },
 OnCloseUp: function(evt){
  var evt = ASPx.Evt.GetEvent(evt);
  if(ASPx.Browser.Firefox && evt.type == "mouseup" && ASPx.Evt.GetEventSource(evt).tagName == "DIV") { 
   var scrollDiv = this.GetListBoxControl().GetScrollDivElement();
   var scrollDivID = scrollDiv ? scrollDiv.id : "";
   if(scrollDivID == ASPx.Evt.GetEventSource(evt).id) 
    return;
  }
  ASPxClientDropDownEditBase.prototype.OnCloseUp.call(this, evt);
 },
 OnDDButtonMouseMove: function(evt){
  return (this.droppedDown ? ASPx.Evt.CancelBubble(evt) : true);
 },
 CloseDropDownByDocumentOrWindowEvent: function(causedByWindowResizing) {
  if(!this.InCallback()) {
   this.OnApplyChangesInternal();
   ASPxClientDropDownEditBase.prototype.CloseDropDownByDocumentOrWindowEvent.call(this, causedByWindowResizing);
  }
  this.filterStrategy.OnDropDownCloseByDocumentOrWindowEvent();
 },
 IsCanToDropDown: function() {
  if(this.loadDropDownOnDemand) {
   var lb = this.GetListBoxControl();
   return (!this.needToLoadDropDown && (lb.GetItemCount() || this.isDropDownModal()));
  }
  return ASPxClientDropDownEditBase.prototype.IsCanToDropDown.call(this);
 },
 OnPopupControlShown: function(){
  if(!this.isInitialized) return;
  if(ASPx.Browser.Opera) 
   this.GetListBoxControl().RestoreScrollTopFromCache();
  if(this.lockListBoxClick)
   this.RemoveLockListBoxClick();
  if(this.InCallback()) 
   this.ShowLoadingDivAndPanel();
  ASPxClientDropDownEditBase.prototype.OnPopupControlShown.call(this);
  if(!this.isShownAtFirst) {
   if(this.GetListBoxControl().ResetItemHeightIfRequired()) {
    this.AdjustListBoxHeight();
    this.InitDropDownSize();
   }
   this.isShownAtFirst = true;
  }
 },
 OnLBSelectedIndexChanged: function(){
  if(!this.lockListBoxClick) {
   this.OnSelectChanged();
   this.filterStrategy.OnSelectedIndexChanged();
   if(this.IsNavigationOnKeyPress()){
    if(!this.droppedDown) {
     ASPx.Selection.Set(this.GetInputElement());
    }
   } else if(this.focused) {
    this.ForceRefocusEditor();
   }
  }
 },
 IsNavigationOnKeyPress: function() {
  var lb = this.GetListBoxControl();
  return lb.IsScrollOnKBNavigationLocked();
 },
 OnListBoxItemMouseUp: function(evt){
  if(!this.lockListBoxClick && !this.InCallback()){
   this.OnApplyChangesInternal();
   this.OnCloseUp(evt);
  }
 },
 OnMouseWheel: function(evt){
  if(this.allowMouseWheel && !this.droppedDown && this.filterStrategy.CanNavigateByKbd()) {
   var wheelDelta = ASPx.Evt.GetWheelDelta(evt);
   if(wheelDelta > 0)
    this.SelectNeighbour(-1);
   else  if(wheelDelta < 0)
    this.SelectNeighbour(1);
   return ASPx.Evt.PreventEvent(evt);
  }
 },
 OnOpenAnotherDropDown: function(){
  this.OnApplyChangesAndCloseWithEvents();
 },
 ParseValue: function() {
  var forceValueChanged = !this.IsValueChanging() && this.IsValueChangeForced();
  var newText = this.GetInputElement().value;
  var oldText = this.GetText();
  var isNeedToParseValue = oldText != newText;
  if(isNeedToParseValue || forceValueChanged) {
   this.StartValueChanging();
   if(this.CanTextBeAccepted(newText, oldText) || forceValueChanged){
    if(isNeedToParseValue || newText)
     this.SetText(newText);
    this.OnChange();
   } else
    this.SetTextInternal(oldText);
   this.EndValueChanging();
  }
 },
 CanTextBeAccepted: function(newText, oldText){
  var notAnyTextCanBeAccepted = this.isDropDownListStyle;
  if(notAnyTextCanBeAccepted){
   var lb = this.GetListBoxControl();
   var newTextPresentInItemCollection = this.GetAdjustedSelectedIndexByText(lb, newText) != -1;
   return newTextPresentInItemCollection;
  }
  var wasTextErased = !newText && oldText;
  if((!wasTextErased) && this.nullText && this.CanApplyNullTextDecoration()) {
   return false;
  }
  return true;
 },
 MakeItemVisible: function(index){
  var lb = this.GetListBoxControl();
  lb.MakeItemVisible(index);
 },
 PerformCallback: function(arg, onSuccess) {
  this.isPerformCallback = true;
  this.CancelLoadCustomRangeOnDropDown();
  this.filterStrategy.OnPerformCallback();
  if(this.needToLoadDropDown) {
   var formatCallbackArg = function(prefix, arg) {  
    arg = arg.toString();
    return (ASPx.IsExists(arg) ? prefix + "|" + arg.length + ';' + arg + ';' : "");
   };
   if(arg === undefined || arg == null)
    arg = "";
   var performArgs = formatCallbackArg(ASPxClientListEdit.CONSTANTS.CALLBACK_PREFIXES.CUSTOM, arg);
   this.onLoadDropDownOnDemandCallbackFinalizedEventHandler = function() {
    var selectedItem = this.listBox.GetSelectedItem();
    if(selectedItem != null)
     this.SetTextInternal(selectedItem.text);
    var lb = this.GetListBoxControl();
    if(lb)
     lb.SetCustomCallbackArg(performArgs);
   };
   var loadItemsRangeArgs = formatCallbackArg(ASPxClientListEdit.CONSTANTS.CALLBACK_PREFIXES.LOAD_RANGE_ITEMS, "0:-2");
   var args = this.FormatLoadDropDownOnDemandCallbackArguments(performArgs + loadItemsRangeArgs);
   this.SendLoadDropDownOnDemandCallback(args, onSuccess);
  } else {
   this.ClearItemsInternal();
   this.GetListBoxControl().PerformCallback(arg, onSuccess);
  }
 },
 ClearItemsInternal: function(){
  ASPxClientComboBoxBase.prototype.ClearItemsInternal.call(this);
  var lbScrollDiv = this.GetListBoxScrollDivElement();
  if(lbScrollDiv)
   lbScrollDiv.scrollTop = "0px";
 },
 SendLoadDropDownOnDemandCallback: function(args, handler) {
  this.ShowInputLoadingPanel();
  this.SendSpecialCallback(args, handler);
 },
 ShowInputLoadingPanel: function() {
  var inputElement = this.GetInputElement();
  var inputParentElement = inputElement.parentNode;
  this.CreateLoadingDiv(inputParentElement, inputElement);
  this.CreateLoadingPanelWithAbsolutePosition(inputParentElement, inputElement);
 },
 FormatLoadDropDownOnDemandCallbackArguments: function(args) {
  var internalArgs = ASPx.IsExists(args) ? args.toString() : "";
  var resultArgs = loadDropDownOnDemandCallbackPrefix + "|0;;";
  return resultArgs + internalArgs;
 },
 CorrectCaretPositionInChrome: function() {
  if(!ASPx.Browser.Chrome) return;
  var currentSelection = ASPx.Selection.GetInfo(this.GetInputElement());
  if(currentSelection.startPos === currentSelection.endPos)
   ASPx.Selection.SetCaretPosition(this.GetInputElement(), 0);
 },
 ForceRefocusEditor: function(evt, isNativeFocus) {
  this.CorrectCaretPositionInChrome();
  this.refocusWhenInputClicked = this.IsElementBelongToInputElement(ASPx.Evt.GetEventSource(evt));
  ASPxClientButtonEditBase.prototype.ForceRefocusEditor.call(this, evt, isNativeFocus);
 },
 OnFocus: function () {
  if(this.needToLoadDropDown) {
   var args = this.FormatLoadDropDownOnDemandCallbackArguments();
   this.SendLoadDropDownOnDemandCallback(args);
  } else
   this.FixButtonState();
  ASPxClientDropDownEditBase.prototype.OnFocus.call(this);
 },
 FixButtonState: function() {
  var lb = this.GetListBoxControl();
  if(lb && this.ddButtonPushed) {
   this.DropDownButtonPop(true);
  }
 },
 getDropDownEventTargets: function() {
  return ASPxClientComboBoxBase.prototype.getDropDownEventTargets.call(this).concat([
   this.isDropDownListStyle ? this.getInputCell() : null,
  ]);
 },
 onDropDownModalChanged: function(enabled) {
  ASPxClientComboBoxBase.prototype.onDropDownModalChanged.call(this, enabled);
  if(!enabled) {
   if(!this.GetItemCount() || !this.filterStrategy.IsFilterMeetRequirementForMinLength())
    setTimeout(this.HideDropDownArea.bind(this, true), 0);
   this.showDropDownModalMessageElement(false);
  }
  this.GetListBoxControl().onDropDownModalChanged(enabled);
  this.UpdateDropDownPositionAndSize();
 },
 onProcessFilterLessMinLength: function() {
  if(this.isDropDownModal() && this.droppedDown)
   this.showDropDownModalMessageElement(true, this.isDropDownListStyle ? this.msgFilterMinLength : (this.msgFilterMinLength + "<br />" + this.msgFilterNoResults));
  if(!this.isDropDownModal())
   this.HideDropDownArea(true);
 },
 onNoResultsFiltering: function() {
  if(this.isDropDownModal() && this.droppedDown)
   this.showDropDownModalMessageElement(true, this.msgFilterNoResults);
 },
 onBeforeFiltering: function() {
  if(this.isDropDownModal() && this.droppedDown)
   this.showDropDownModalMessageElement(false);
 },
 showDropDownModalMessageElement: function(visible, message) {
  var listBox = this.GetListBoxControl();
  if(!listBox) 
   return;
  if(visible && !this.dropDownModalMessageElement) {
   this.dropDownModalMessageElement = document.createElement("div");
   this.dropDownModalMessageElement.className = "dxdd-info";
   listBox.GetMainElement().parentNode.insertBefore(this.dropDownModalMessageElement, listBox.GetMainElement());
  }
  else if(visible)
   this.dropDownModalMessageElement.style.display = "";
  else if(!visible && this.dropDownModalMessageElement)
   this.dropDownModalMessageElement.style.display = "none";
  if(visible && message)
   this.dropDownModalMessageElement.innerHTML = message;
  if(this.dropDownModalMessageElement)
   ASPx.SetElementDisplay(listBox.GetMainElement(), !visible);
 },
 onDropDownApplyCommandClick: function() {
  this.OnApplyChangesAndCloseWithEvents();
 },
 onDropDownCloseCommandClick: function() {
  this.OnEscape();
 },
 SetItemHtml: function(index, html) {
  this.GetListBoxControl().SetItemHtml(index, html);
 },
 SetItemTooltip: function(index, tooltip) { this.GetListBoxControl().SetItemTooltip(index, tooltip); },
 SetItemAttribute: function(index, attributeName, attributeValue) { this.GetListBoxControl().SetItemAttribute(index, attributeName, attributeValue); },
 AddItemCssClass: function(index, className) { this.GetListBoxControl().AddItemCssClass(index, className); },
 RemoveItemCssClass: function(index, className) { this.GetListBoxControl().RemoveItemCssClass(index, className); },
 SetItemTextCellHtml: function(itemIndex, textCellIndex, html) { this.GetListBoxControl().SetItemTextCellHtml(itemIndex, textCellIndex, html); },
 SetItemTextCellTooltip: function(itemIndex, textCellIndex, tooltip) { this.GetListBoxControl().SetItemTextCellTooltip(itemIndex, textCellIndex, tooltip); },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attributeName, attributeValue) { this.GetListBoxControl().SetItemTextCellAttribute(itemIndex, textCellIndex, attributeName, attributeValue); },
 AddItemTextCellCssClass: function(itemIndex, textCellIndex, className) { this.GetListBoxControl().AddItemTextCellCssClass(itemIndex, textCellIndex, className); },
 RemoveItemTextCellCssClass: function(itemIndex, textCellIndex, className) { this.GetListBoxControl().RemoveItemTextCellCssClass(itemIndex, textCellIndex, className); },
 GetAccessibilityText: function() {
  var helper = this.GetAccessibilityHelper();
  return helper && helper.getListSelectedItemText() || this.GetCurrentText();
 }
});
ASPx.Ident.scripts.ASPxClientComboBox = true;
ASPxClientComboBox.Cast = ASPxClientControl.Cast;
var CallbackProcessingStateManager = function(){
 var states = { 
  Default:   0,
  Rollback:     1,
  Apply:     2,
  ApplyAfterRollback: 3
 };
 var state = states.Default;
 return {
  ResetState: function() {
   state = states.Default;
  },
  IsApply: function() {
   return state == states.Apply;
  },
  IsRollback: function() {
   return state == states.Rollback;
  },
  IsApplyAfterRollback: function() {
   return state == states.ApplyAfterRollback;
  },
  NoFilterPostProcessing: function() {
   return !this.IsApply() && !this.IsApplyAfterRollback() && !this.IsRollback();
  },
  SetRollback: function() {
   if(state == states.Default)
    state = states.Rollback;
  },
  SetApply: function() {
   if(state == states.Default)
    state = states.Apply;
  },
  SetApplyAfterRollback: function() {
   if(state == states.Default || state == states.Apply)
    state = states.ApplyAfterRollback;
  },
  OnCallbackResult: function(filterRollbackRequired) {
   if(state == states.Apply) {
    state = filterRollbackRequired ? states.ApplyAfterRollback : states.Default;
    return;
   }
   if(state == states.Rollback) {
    state = states.ApplyAfterRollback;
    return;
   }
   if(state == states.ApplyAfterRollback) {
    state = states.Default;
    return;
   }
  }
 };
};
var ASPxClientNativeComboBox = ASPx.CreateClass(ASPxClientComboBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.initSelectedIndex = -1;
  this.raiseValueChangedOnEnter = false;
 },
 InlineInitialize: function () {
  ASPxClientComboBoxBase.prototype.InlineInitialize.call(this);
  var lb = this.GetListBoxControl();
  if(lb != null) lb.SetMainElement(this.GetMainElement());
  if(this.initSelectedIndex == -1) { 
   this.SelectIndex(this.initSelectedIndex, true);
  }
 },
 FindInputElement: function(){
  return this.GetMainElement();
 }, 
 GetDropDownInnerControlName: function(suffix){
  return this.name + suffix;
 },
 PerformCallback: function(arg) {
  this.GetListBoxControl().PerformCallback(arg);
 },
 GetTextInternal: function(){
  var selectedItem = this.GetSelectedItem();
  return (selectedItem != null) ? selectedItem.text : "";
 },
 HasTextDecorators: function() {
  return false;
 },
 SetText: function (text){
  var lb = this.GetListBoxControl();
  var index = this.FindItemIndexByText(lb, text);
  this.SelectIndex(index, false);
  this.SetLastSuccessText((index > -1) ? text : "");
  this.SetLastSuccessValue((index > -1) ? lb.GetValue() : null);
 },
 GetValue: function(){
  var selectedItem = this.GetSelectedItem();
  return (selectedItem != null) ? selectedItem.value : null;
 },
 SetValue: function(value){
  var lb = this.GetListBoxControl();
  if(lb){
   lb.SetValue(value);
   var item = lb.GetSelectedItem();
   var text = item ? item.text : value;
   this.SetLastSuccessText(item != null ? text : "");
   this.SetLastSuccessValue(item != null ? item.value : null);
  }
 },
 ForceRefocusEditor: function(){
 },
 OnCallback: function(result) {
  this.GetListBoxControl().OnCallback(result);
  if(this.GetItemCount() > 0)
   this.SetSelectedIndex(0);
 },
 OnTextChanged: function() {
  this.OnChange();
 },
 OnFocus: function() { },
 SetTextInternal: function(text){
 },
 SetTextBase: function(text){
 },
 ChangeEnabledAttributes: function(enabled){
  this.GetMainElement().disabled = !enabled;
 }
});
var AccessibilityHelperComboBox = ASPx.CreateClass(ASPx.AccessibilityHelperBase, {
 constructor: function(comboBox) {
  this.constructor.prototype.constructor.call(this, comboBox);
  this.currentValue = null;
 },
 SetLabelAttribute: function(text, isItemSelected) {
  this.currentValue = this.control.GetValue();
  var message = text !== null ? this.getLabelText(text, isItemSelected) : this.getListSelectedItemText();
  this.PronounceMessage(message);
 },
 PronounceMessage: function(text) {
  var input = this.getInputElement();
  var expandArg = {"aria-expanded" : this.control.droppedDown };
  ASPx.AccessibilityHelperBase.prototype.PronounceMessage.call(this, text, expandArg, ASPx.CloneObject(expandArg), null, input);
 }, 
 SetExpandedState: function(expanded) {
  if(this.currentValue != this.control.GetValue()) {
   this.SetLabelAttribute(null, null);
  } else {
   var input = this.getInputElement();
   var expandArg =  { "aria-expanded": expanded };
   this.changeActivityAttributes(input, expandArg);
   this.changeActivityAttributes(this.getItem(true), expandArg);
  }
 },
 getLabelText: function(text, isItemSelected) {
  var blankText = ASPx.AccessibilitySR.BlankEditorText;
  if(!text)
   text = blankText;
  var itemsCount = this.getListBoxControl().GetVisibleItemCount();
  var formatString = ASPx.AccessibilitySR.ComboBoxFilteringResultFormatString;
  if(!isItemSelected || itemsCount == 1)
   formatString += ASPx.AccessibilitySR.ComboBoxCurrentTextFormatString;
  return ASPx.Str.ApplyReplacement(formatString, [["{0}", itemsCount],
   ["{1}", (isItemSelected || !this.control.lastSuccessText) ? text : this.control.lastSuccessText],
   ["{2}", this.getInputElement().value || blankText]]);
 },
 getListBoxControl: function() { return this.control.GetListBoxControl(); },
 getInputElement: function() { return this.control.GetInputElement(); },
 getListSelectedItemText: function() {
  var lb = this.getListBoxControl();
  var selectedItem = lb.GetSelectedItem();
  var itemText = "";
  if(!!selectedItem) {
   var formatString = ASPx.AccessibilitySR.ItemPositionFormatString;
   var visibleIndex = this.control.isCallbackMode ? selectedItem.index + 1 : lb.GetIndexVisibleItem(selectedItem);
   var itemPositionText = ASPx.Str.ApplyReplacement(formatString, [["{0}", visibleIndex], ["{1}", lb.GetVisibleItemCount()]]);
   itemText = selectedItem.text + itemPositionText;
  } else {
   var input = this.getInputElement();
   itemText = !!input.value ? input.value : ASPx.AccessibilitySR.BlankEditorText;
  }
  return itemText;
 }
});
function setValueOptimizeHelper() {
 var itemCollectionWasChangedSinceLastSetValue = false;
 function canReSetValue() {
  return itemCollectionWasChangedSinceLastSetValue;
 }
 function onSetValue() {
  itemCollectionWasChangedSinceLastSetValue = false;
 }
 return {
  onItemCollectionChanged: function () {
   itemCollectionWasChangedSinceLastSetValue = true;
  },
  setValue: function (comboBox, newValue, methodName) {
   var item = comboBox.FindItemByValue(newValue);
   var reSetValue = comboBox.GetValue() === newValue;
   if (reSetValue && !canReSetValue() && (!item || item.selected)) return;
   comboBox.SetValueInternal(newValue);
   onSetValue();
  }
 };
}
ASPx.CBDDButtonMMove = function(evt){
 return ASPx.GetDropDownCollection().OnDDButtonMouseMove(evt);
};
function aspxCBMouseWheel(evt){
 var srcElement = ASPx.Evt.GetEventSource(evt);
 var focusedCB = ASPx.GetDropDownCollection().GetFocusedDropDown();
 if(focusedCB != null && ASPx.GetIsParent(focusedCB.GetMainElement(), srcElement))
  return focusedCB.OnMouseWheel(evt);
}
var ComboBoxDisabledFilterStrategy = ASPx.CreateClass(ASPx.ListEditFilterStrategyBase, {
 constructor: function(comboBox) {
  this.constructor.prototype.constructor.call(this, comboBox.filterTimer, comboBox.filterMinLength, comboBox.isCallbackMode);
  this.comboBox = comboBox;
  this.callbackProcessingStateManager = new CallbackProcessingStateManager();
 },
 OnDropDownCloseByDocumentOrWindowEvent: function() {
  if(this.comboBox.InCallback())
   this.callbackProcessingStateManager.SetApply();
 },
 OnAfterCallbackFinally: function() {
  if(this.callbackProcessingStateManager.IsApply() || this.callbackProcessingStateManager.IsApplyAfterRollback()) {
   this.comboBox.OnApplyChangesAndCloseWithEvents();
   this.callbackProcessingStateManager.ResetState();
  }
 },
 IsCloseByEnterLocked: function() { return false; },
});
var ComboBoxIncrementalFilterStrategyBase = ASPx.CreateClass(ASPx.ListEditIncrementalFilterStrategyBase, {
 constructor: function(comboBox) {
  this.constructor.prototype.constructor.call(this, comboBox.filterTimer, comboBox.filterMinLength, comboBox.isCallbackMode);
  this.comboBox = comboBox;
  this.isDropDownListStyle = comboBox.isDropDownListStyle;
  this.callbackProcessingStateManager = new CallbackProcessingStateManager();
  this.isTotallyMismatchedFilter = false;
 },
 OnInput: function() {
  if (!this.comboBox.allowNull && !this.GetInputFilterValue())
   this.ClearFilterApplied();
  ASPx.ListEditIncrementalFilterStrategyBase.prototype.OnInput.call(this);
 },
 OnKeyDown: function(evt) {
  var cbInputElement = this.comboBox.GetInputElement();
  var selInfo = ASPx.Selection.GetInfo(cbInputElement);
  if(selInfo.startPos != selInfo.endPos && evt.keyCode == ASPx.Key.Backspace) {
   var currentText = cbInputElement.value;
   var cutText = currentText.slice(0, selInfo.startPos) + currentText.slice(selInfo.endPos);
   var newFilter = ASPx.Str.PrepareStringForFilter(cutText);
   if(cutText != currentText && this.comboBox.filterStrategy.FilterCompareLower(newFilter)) {
    cbInputElement.value = cutText; 
    ASPx.Selection.SetCaretPosition(cbInputElement, selInfo.startPos);
   }
  }
 },
 OnEscape: function() {
  this.FilterStopTimer();
  if(this.InCallback())
   this.callbackProcessingStateManager.SetRollback();
 },
 OnUndo: function() {
  if(this.isCallbackMode)
   this.Filtering();
  else {
   this.FilteringStopClient();
   this.GetListBoxControl().EnsureSelectedItemVisible();
  }
 },
 OnApplyChanges: function () {
  if (this.IsFilterTimerActive()) {
   this.FilterNowAndApply();
   return true;
  }
  return false;
 },
 OnCancelChanges: function () {
  this.OnFilterRollback();
 },
 OnClearButtonClick: function () {
  if (!this.InCallback()) {
   this.FilteringStop();
   if (this.isCallbackMode)
    this.Filtering();
  }
 },
 OnDropDownCloseByDocumentOrWindowEvent: function() {
  if(this.InCallback())
   this.callbackProcessingStateManager.SetApply();
 },
 PreventEndCallbackRising: function() {
  this.comboBox.preventEndCallbackRising = true;
 },
 OnBeforeCallbackFinally: function() {
  this.currentCallbackIsFiltration = false;
 },
 OnAfterCallbackFinally: function() {
  var filterRollbackRequired = false;
  if(this.callbackProcessingStateManager.IsApply() || this.callbackProcessingStateManager.IsApplyAfterRollback()) {
   this.ApplyAfterFinalFiltrationCallback();
   filterRollbackRequired = this.comboBox.IsFilterRollbackRequiredAfterApply();
  }
  if(this.callbackProcessingStateManager.IsRollback())
   filterRollbackRequired = true;
  this.callbackProcessingStateManager.OnCallbackResult(filterRollbackRequired);
  if(filterRollbackRequired)
   window.setTimeout(this.OnFilterRollback.bind(this), 0);
 },
 OnPerformCallback: function() {
  this.ClearFilter();
 },
 CanNavigateByKbd: function() {
  return this.IsFilterMeetRequirementForMinLength();
 },
 ApplyAfterFinalFiltrationCallback: function() {
  var itemIsSelected = this.TrySelectItemAfterFilter();
  this.comboBox.HideDropDownArea();
  var requiredApplyFailed = this.comboBox.isDropDownListStyle && !itemIsSelected && this.comboBox.focused && this.callbackProcessingStateManager.IsApply();
  if(requiredApplyFailed)
   this.comboBox.ShowDropDownArea(true);
  var needApplyChanges = itemIsSelected || !this.comboBox.focused;
  if(needApplyChanges)
   this.comboBox.OnApplyChangesInternal();
 },
 TrySelectItemAfterFilter: function() {
  var lb = this.GetListBoxControl();
  if(!lb) return false;
  var selectedItem;
  if(this.isDropDownListStyle)
   selectedItem = lb.GetVisibleItemCount() == 1 ? lb.GetItem(0) : null;
  else
   selectedItem = lb.FindItemByText(this.filter);
  if(selectedItem) {
   lb.SelectIndexSilent(selectedItem.index);
   this.comboBox.SetTextInternal(selectedItem.text);
  }
  return !!selectedItem;
 },
 IsEnabled: function() {
  return this.comboBox.GetEnabled();
 },
 Filtering: function(fromApi) {
  ASPx.ListEditIncrementalFilterStrategyBase.prototype.Filtering.call(this, fromApi);
  this.comboBox.EnsureClearButtonVisibility();
 },
 ShouldClearFilterBeforeFiltering: function(filter) {
  return this.TryRollbackLastSuccessText(this.GetInputFilterValue());
 },
 OnBeforeFiltering: function() {
  this.comboBox.onBeforeFiltering();
  this.EnsureDropDownAreaStateBeforeFiltering();
  if(this.isCallbackMode && !this.comboBox.droppedDown && this.comboBox.isNeedToForceFirstShowLoadingPanel)
   this.comboBox.ForceShowLoadingPanel();
 },
 OnAfterFiltering: function() {
  if(!this.isCallbackMode)
   this.ResetCallbackState();
 },
 OnFilteringCancelled: function(filteringFromApi) {
  if(this.comboBox.isCallbackMode) {
   var firstItem = this.GetListBoxControl().GetItem(0);
   if(firstItem && firstItem.selected) {
    this.HighlightTextAfterCallback(firstItem.text);
    this.EnsureDropDownAreaStateBeforeFiltering();
   }
   else if(filteringFromApi)
    this.EnsureDropDownAreaStateBeforeFiltering();
  }
  this.ResetCallbackState();
 },
 OnFilterRollback: function() {
  if(this.InCallback() && this.currentCallbackIsFiltration) 
   return;
  if(this.isCallbackMode && this.filterInitialized) {
   var listBox = this.GetListBoxControl();
   this.callbackProcessingStateManager.SetApplyAfterRollback();
   if(this.comboBox.GetText() != "" && this.comboBox.isDropDownListStyle) {
    listBox.ClearItems();
    this.needEmptyFilterBeforeFiltering = false;
    var currentSelectedItemCbArgs = ASPx.FilteringUtils.FormatCallbackArg(currentSelectedItemCallbackPrefix, "");
    this.comboBox.SendSpecialCallback(currentSelectedItemCbArgs);
   } else
    this.Filtering();
   this.SetFilter(this.comboBox.GetText());
   this.SetHighlighting(this.filter);
   this.ClearFilterApplied();
  }
 },
 NotifyCollectionChanged: function() {
  this.comboBox.CollectionChanged(true);
 },
 TryProcessFilterLessMinLength: function(oldFilter) {
  this.comboBox.onProcessFilterLessMinLength();
  this.ResetCallbackState();
  this.GetListBoxControl().SelectIndexSilent(-1, false);
  return true;
 },
 GetSelectedIndex: function() {
  return this.comboBox.GetSelectedIndex();
 },
 ResetCallbackState: function() {
  this.callbackProcessingStateManager.ResetState();
 },
 HighlightTextAfterCallback: function() { },
 IsCloseByEnterLocked: function() { return false; },
 TryRollbackLastSuccessText: function(filter) {
  if(this.comboBox.allowNull || filter) return false;
  var inpValue = this.comboBox.lastSuccessText;
  var inputElement = this.comboBox.GetInputElement();
  if(this.comboBox.HasTextDecorators()) {
   this.comboBox.SetRawValue(inpValue);
   if(this.comboBox.CanApplyTextDecorators())
    this.comboBox.SetInputValue(this.comboBox.GetDecoratedText(inpValue));
   else
    this.comboBox.SetInputValue(inpValue);
  }
  else if(inputElement.value != inpValue)
   this.comboBox.SetInputValue(inpValue);
  if(this.comboBox.focused)
   ASPx.Selection.Set(inputElement, 0, inputElement.value.length);
  var lb = this.comboBox.GetListBoxControl();
  if(lb) {
   if(this.comboBox.lastSuccessValue != null)
    lb.SetValue(this.comboBox.lastSuccessValue);
   else {
    var index = lb.FindItemIndexByText(this.comboBox.lastSuccessText);
    lb.SelectIndexSilent(index);
   }
  }
  this.comboBox.ShowCurrentItemImage();
  return true;
 },
 EnsureDropDownAreaStateBeforeFiltering: function() {
  var showDropDown = this.CanShowDropDownOnFocus(this.filter);
  if(this.callbackProcessingStateManager.NoFilterPostProcessing() && showDropDown) {
   var lb = this.GetListBoxControl();
   lb.LockScrollHandler();
   this.EnsureShowDropDownArea();
   lb.UnlockScrollHandler();
  } else if(!showDropDown)
   this.comboBox.HideDropDownArea();
 },
 EnsureShowDropDownArea: function() {
  if(!this.comboBox.droppedDown && this.comboBox.focused) {
   this.comboBox.CancelLoadCustomRangeOnDropDown();
   this.comboBox.ShowDropDownArea(true);
  }
 },
 CanShowDropDownOnFocus: function(filter) {
  if(filter != "")
   return true;
  return !!this.comboBox.showDropDownOnFocus ? this.comboBox.showDropDownOnFocus !== "Never" : true;
 },
 AllowEmptyFilterResults: function() {
  return !this.comboBox.isDropDownListStyle;
 },
 GetInputFilterValue: function() {
  var rawValue = this.comboBox.GetRawValue();
  return rawValue !== null && rawValue !== undefined ? rawValue : this.comboBox.GetInputElement().value;
 },
 GetListBoxControl: function() {
  return this.comboBox.GetListBoxControl();
 },
 OnBeforeFilteringOnClient: function(filter) {
  var comboBox = this.comboBox;
  if(comboBox.isDropDownListStyle) {
   if(this.GetInputFilterValue() != filter)
    comboBox.SetInputValue(filter);
   if(ASPx.IsExists(comboBox.GetRawValue()))
    comboBox.SetRawValue(filter);
   this.SetFilter(filter);
  }
  this.TryRollbackLastSuccessText(filter);
 },
 OnAfterFilteringOnClientCore: function (filter, firstSatisfyItemIndex) {
  if(firstSatisfyItemIndex !== -1 && this.CanShowDropDownOnFocus(filter))
   this.GetListBoxControl().CorrectCellWidthsOnFirstRowItemReplacement(0, firstSatisfyItemIndex);
  else {
   this.comboBox.onNoResultsFiltering();
   if(!this.comboBox.isDropDownModal())
    this.comboBox.HideDropDownArea(true);
  }
  this.needEmptyFilterBeforeFiltering = false;
 },
 FilteringStop: function() {
  if(!this.isCallbackMode)
   this.FilteringStopClient();
 },
 FilteringStopClient: function() {
  this.MakeAllItemsVisible();
  this.ClearFilter();
  this.DiscardHighlighting();
 },
 MakeAllItemsVisible: function() {
  ASPx.ListEditIncrementalFilterStrategyBase.prototype.MakeAllItemsVisible.call(this);
  this.NotifyCollectionChanged();
 },
 FilterNowAndApply: function() {
  this.callbackProcessingStateManager.SetApply();
  this.Filtering();
  if(!this.comboBox.isCallbackMode)
   this.comboBox.OnApplyChangesInternal();
 },
 InCallback: function() {
  return this.comboBox.InCallback();
 },
 OnCallbackCore: function(highlighting, newFilterLength) {
  if(this.currentCallbackIsFiltration) {
   var lb = this.GetListBoxControl();
   if(!lb.GetItemCount() || !this.CanShowDropDownOnFocus(this.filter)) {
    this.comboBox.onNoResultsFiltering();
    if(!this.comboBox.isDropDownModal())
     this.comboBox.HideDropDownArea(true);
   }
   else {
    this.OnFilterCallbackHighlightAndSelect(highlighting, newFilterLength);
    var isNeedToKeepDropDownVisible = !this.comboBox.isPerformCallback && this.callbackProcessingStateManager.NoFilterPostProcessing();
    if(!this.CanShowDropDownOnFocus(this.filter))
     this.comboBox.HideDropDownArea();
    else if(isNeedToKeepDropDownVisible)
     this.EnsureShowDropDownArea();
    this.OnEndFiltering();
   }
  }
  else
   this.RefreshHighlighting();
 },
 OnFilterCallbackHighlightAndSelect: function(highlighting, newFilterLength) {
  var listBox = this.GetListBoxControl();
  var firstItemText = listBox.GetItem(0).text;
  var isTextClearing = !this.comboBox.allowNull && this.IsEmptyFilter() && firstItemText;
  if(!isTextClearing) {
   var isFilterRollBack = this.CheckForFilterRollback(newFilterLength);
   var isNonFilterChangingCallback = (listBox.GetSelectedItem() == null);
   this.isTotallyMismatchedFilter = this.TryRollbackLastSuccessText(this.filter);
   var isNullState = this.comboBox.allowNull && !this.filter && !listBox.FindItemByText(this.filter);
   if(!this.isTotallyMismatchedFilter && !isNullState)
    this.SetHighlighting(this.filter, highlighting);
   if(!this.isTotallyMismatchedFilter && !isNullState && (isFilterRollBack || isNonFilterChangingCallback))
    this.HighlightTextAfterCallback(firstItemText);
   else
    this.DiscardHighlighting();
  }
  else
   this.TryRollbackLastSuccessText(this.filter);
 },
 CheckForFilterRollback: function(newFilterLength) {
  var filter = ASPx.Str.PrepareStringForFilter(this.filter);
  if(typeof(newFilterLength) === "number" && filter.length > newFilterLength) {
   this.SetFilter(filter.substring(0, newFilterLength));
   this.comboBox.SetInputValue(this.filter);
   return true;
  }
  return false;
 },
 SendCallbackCore: function() {
  this.comboBox.SendCallback();
 },
 SupportsFilterCorrection: function() {
  return this.isDropDownListStyle;
 },
 SetListBoxSuggestionSelection: function() {
  var lb = this.GetListBoxControl();
  var singleItem = lb && lb.GetVisibleItemCount() == 1;
  var canSuggest = this.comboBox.isDropDownListStyle && this.comboBox.droppedDown && singleItem;
  var itemIndex = -1;
  if(canSuggest) {
   itemIndex = lb.GetFirstFilteredItemIndex();
   this.comboBox.SelectIndexSilent(lb, itemIndex);
  }
  if(this.comboBox.accessibilityCompliant)
   this.comboBox.GetAccessibilityHelper().SetLabelAttribute(canSuggest ? lb.GetItem(itemIndex).text : this.GetInputFilterValue(), canSuggest);
 },
 FilteringBackspace: function() {
  var currentText = this.GetInputFilterValue();
  if(currentText.length)
   this.comboBox.SetInputValue(currentText.slice(0, -1));
  this.FilterStartTimer();
 },
 RaiseItemFilteringEvent: function(item, filter, isFit) {
  return this.comboBox.RaiseItemFiltering(item, filter, isFit);
 },
 RaiseCustomHighlightingEvent: function(filter, callbackHighlighting) {
  return this.comboBox.RaiseCustomHighlighting(filter, callbackHighlighting);
 }
});
var ComboBoxContainsFilterStrategy = ASPx.CreateClass(ComboBoxIncrementalFilterStrategyBase, {
 IsSatisfy: function(text, filter) {
  return ASPx.Str.PrepareStringForFilter(text).indexOf(filter) != -1;
 },
 OnDropDownHideArea: function() {
  if(!this.isCallbackMode)
   this.FilteringStopClient();
 },
 OnDropDownButtonClick: function() {
  var lb = this.GetListBoxControl();
  if(lb && lb.GetVisibleItemCount() == 0 && this.isDropDownListStyle)
   this.comboBox.OnCancelChanges();
 },
 OnTextChanged: function() {
  if(!this.comboBox.IsFocusEventsLocked())
   if(!this.comboBox.ChangedByEnterKeyPress())
    this.OnFilterRollback();
 },
 OnBeforeCallbackFinally: function () {
  this.RefreshHighlighting();
  this.SetListBoxSuggestionSelection();
  ComboBoxIncrementalFilterStrategyBase.prototype.OnBeforeCallbackFinally.call(this);
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  ComboBoxIncrementalFilterStrategyBase.prototype.OnEndFiltering.call(this, visibleCollectionChanged);
  this.SetListBoxSuggestionSelection();
 },
 IsCloseByEnterLocked: function() {
  if(this.comboBox.isDropDownListStyle) {
   if(this.IsFilterTimerActive()) return false;
   var lb = this.GetListBoxControl();
   if(lb && lb.GetVisibleItemCount() == 1) return false;
   var selectedItem = this.comboBox.GetSelectedItem();
   if(selectedItem)
    if(this.GetInputFilterValue() == selectedItem.text)
     return false;
   return true;
  }
  return false;
 },
});
var ComboBoxStartsWithFilterStrategy = ASPx.CreateClass(ComboBoxIncrementalFilterStrategyBase, {
 HighlightTextAfterCallback: function(firstItemText) {
  var lb = this.GetListBoxControl();
  this.FilteringHighlightCompletedText(firstItemText);
  if(this.comboBox.accessibilityCompliant)
   this.comboBox.GetAccessibilityHelper().SetLabelAttribute(firstItemText, true);
  if(!this.comboBox.isPerformCallback)
   this.comboBox.SelectIndexSilent(lb, 0);
 },
 OnFirstSatisfiedItemFound: function(index, text, isTextClearing) {
  if(this.needEmptyFilterBeforeFiltering && isTextClearing) return;
  var lb = this.GetListBoxControl();
  if(!isTextClearing)
   this.FilteringHighlightCompletedText(text);
  this.comboBox.SelectIndexSilent(lb, isTextClearing ? -1 : index, true);
 },
 FilteringHighlightCompletedText: function(filterItemText) {
  var input = this.comboBox.GetInputElement();
  ASPx.StartWithFilteringUtils.HighlightSuggestedText(input, filterItemText, this.comboBox,
   this.comboBox.restartCurrentUserInputTimer.bind(this.comboBox));
  if(ASPx.IsExists(this.comboBox.GetRawValue()))
   this.comboBox.SyncRawValueIfHasTextDecorators(false);
 },
 IsSatisfy: function(text, filter) {
  return ASPx.Str.PrepareStringForFilter(text).indexOf(filter) == 0;
 },
 OnDropDownHideArea: function() {
  this.FilteringStop();
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  ComboBoxIncrementalFilterStrategyBase.prototype.OnEndFiltering.call(this, visibleCollectionChanged);
  var selectedItem = this.GetListBoxControl().GetSelectedItem();
  if (selectedItem)
   this.GetListBoxControl().MakeItemVisible(selectedItem.index);
  if(this.comboBox.accessibilityCompliant) {
   this.comboBox.GetAccessibilityHelper().SetLabelAttribute(!!selectedItem ? selectedItem.text : this.GetInputFilterValue(), !!selectedItem);
  }
 },
 OnAfterEnter: function() {
  var inputElement = this.comboBox.GetInputElement();
  ASPx.Selection.SetCaretPosition(inputElement);
 },
 TrySelectItemAfterFilter: function() {
  var lb = this.GetListBoxControl();
  var selectedItem = lb.GetItem(0);
  return !!selectedItem;
 }
});
ASPx.ComboBoxDisabledFilterStrategy = ComboBoxDisabledFilterStrategy;
ASPx.ComboBoxContainsFilterStrategy = ComboBoxContainsFilterStrategy;
ASPx.ComboBoxStartsWithFilterStrategy = ComboBoxStartsWithFilterStrategy;
window.ASPxClientComboBoxBase = ASPxClientComboBoxBase;
window.ASPxClientComboBox = ASPxClientComboBox;
window.ASPxClientNativeComboBox = ASPxClientNativeComboBox;
})();

